// Some simple constructs
class C {
    int f;
    static public void main(String[] args) {
	C x1 = new C();
	C x2 = new C();

	C y1 = null;
	C y2 = new C();

	int x = x1.foo(y1).f; // target of f may be null, since y1 may be null

	int y = x2.foo(y2).f; // target of f cannot be null, since y2 can not be null
    }

    C foo(C q) {
	return q;
    }
}
